//// library ////
module.exports = {init_middle: init_middle,
                  set_key: set_key,
                  auth: auth,
                  prov: prov,
                  otp_response: otp_response};

var sync    = require("synchronize");
var request = require("request");

function p(o) {
  console.log(o);
  return o;
}
function init_middle(app) {app.use(function(req,res,next){sync.fiber(next);});}
function encode2(call2) {return encodeURIComponent(JSON.stringify(call2));}
var urls = ["https://a.totp.me:8443/prot",
            "https://b1.totp.me:18443/prot2",
            "https://b2.totp.me:28443/prot2",
            "https://b3.totp.me:38443/prot2",
            "https://b4.totp.me:48443/prot2"];
function fetch(urls, action, key, arg) {
  if (0 == urls.length) throw Error("could not connect to any servers");
  var results;
  try {
    results = sync.await(
                request(urls[0]+"?action="+action+"&key="+key+"&arg="+arg,
                sync.defers()));
  } catch (e) {}
  return (results && results[0].statusCode == 200)
         ? results[1]
         : fetch (urls.slice(1), action, key, arg);
}
function make_client_msg(key, call2) {
  return fetch(urls, "make-client-msg", key, encode2(call2));
}
function decode_server_msg(key, msg, sid) {
  var sid2 = sid ? JSON.parse(sid) : 0;
  return JSON.parse(
           fetch(urls.slice(sid2,sid2+1), "decode-server-msg", key, msg));
}

////

//var reqs = "totp:outstanding-reqs";
var reqfns = {}; //should expire entries to free mem
function push_outstanding_request(oreq) { reqfns[oreq[0]] = oreq; }
function remove_outstanding_request(reqid) {
  var ans = reqfns[reqid];
  delete reqfns[reqid];
  return ans;
}
var next_id = 0;
var key;
function set_key(k) {key = k;}
function call1(fn, u, h) {
  var reqid = ++next_id; //concurrency: fine, node has only 1 cpu-bound thread
  push_outstanding_request ([reqid,u,h]);
  return make_client_msg (key, [reqid,fn,u]);
}
function prov(u,h){return call1("prov",u,h);}
function auth(u,h){return call1("auth",u,h);}

////

function otp_response(req, res) {
  var res2 = decode_server_msg(key, req.param("res"), req.param("sid"));
  var oreq = remove_outstanding_request(res2[0]);
  return res.redirect(oreq[2](req.session, oreq[1], res2[1].length != 0));
}
